/////////////////////////////////////////////////////////////////
//Henon Map als Fraktal  - Kapitel Fraktale
//////////////////////////////////////////////////////////////

//Die beiden wesentlichen Parameter c1 und c2
float c1 = 1.4;
float c2 = 0.3;
//Bildausschnitt zu Beginn:
float xU =-1.5; float xO =1.5;
float yU = -0.4; float yO = 0.4;
//Einige Zwischenspeicher:
float xNeuF, yNeuF, xUNeu, xONeu, yUNeu, yONeu;
//Für starkes Zoomen müssen sehr viele Iterationen durchgeführt werden.
//Damit die Fehler dabei nicht zu groß werden, muss man mit double-Werten rechnen
double xAlt, yAlt, xNeu, yNeu; 
boolean fluchtBereich;
PFont font;
int w = 800 ; int h= 800; 
int n, i, j, xK, yK;
color[] farben = {color(255,0,0),color(0,180,0),color(0,0,255),color(255,0,255),color(0,255,255),color(0,0,0)};                   ;
double d;
String s;

///////////////////////////////////////////////////////////////////////////
//"settings" lässt Parameter in size zu!
////////////////////////////////////////////////////////////////////////////////
void settings() {
  size(w, h);
} 


//Initialisierungen  
void setup(){ 
  background(255);
  surface.setSize(w,h);
  fill(0); textSize(12);
  font = loadFont("ArialMT-12.vlw");
  smooth();
  n= 50000; i=0; j=0;
  xAlt = 0; yAlt = 0;
  xUNeu = 0; xONeu = 0;
  yUNeu = 0; yUNeu = 0;
  fluchtBereich = false;
  iteriere(xAlt,yAlt,n);
}
 
 void draw(){

 //Fluchtbereich zeichnen
 if(fluchtBereich){
   for(int l = 1; l<=w; l++){
     for(int s =1; s<=h; s++){
       xAlt = map(l,0,w,xU,xO);
       yAlt = map(s,0,h, yO,yU);
       for(int k =0; k <= 100; k++){
         xNeu = yAlt+1-c1*xAlt*xAlt;
         yNeu = c2*xAlt; 
         xAlt = xNeu; yAlt = yNeu;
      }
      d = Math.sqrt(xAlt*xAlt + yAlt*yAlt);
      if(d<= 1000){stroke(255,255,0,40); point(l,s);
      }else{stroke(0,0,255); point(l,s);}
     }   
   }     
  fluchtBereich = false;  
  xAlt=0; yAlt=0;
 }
}
//////////////////////////////////////
//

void keyPressed(){  
  if (key == ENTER){  
     fluchtBereich = true; 
  } 
  //zehnfach Iteration "von Hand" ausgelöst
  //falls die Punkte zu wenig dicht liegen
  if (key == TAB){  
    for(int q = 0; q <=10; q++){
     iteriere(xAlt,yAlt,n);    
    }
    println("x = "+xAlt+"  y = "+yAlt);//nur zur Kontrolle  
  }  
} 
/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird 10-fach vergrößert
//////////////////////////////////////////////////////
void mousePressed() {   
  background(255);
  xAlt =0; yAlt =0;
  xUNeu = map(mouseX,0,w,xU,xO)-(xO-xU)/10;
  xONeu = map(mouseX,0,w,xU,xO)+(xO-xU)/10;
  yUNeu = map(mouseY,0,h, yO,yU)-(yO-yU)/10;
  yONeu = map(mouseY,0,h, yO,yU)+(yO-yU)/10;
  xU = xUNeu; xO = xONeu; yU = yUNeu; yO = yONeu;
  j = (j+1) % 6;//um die Farbe zu wechseln
  i=0;
  iteriere(xAlt,yAlt,n); 
}
//////////////////////////////////////////////////////////
//Eine erste Iteration wird im setup() ausgelöst
//Durch drücken der Tab-Taste können weitere Iterationen 
//angefordert werden
////////////////////////////////////////////////////////
void iteriere(double XAlt, double YAlt, int N){  
   xAlt = XAlt;
   yAlt = YAlt;
   this.n =   N;
   while(i <=n){
     xNeu = yAlt+1-c1*xAlt*xAlt; xNeuF = (float)xNeu;
     yNeu = c2*xAlt; yNeuF = (float)yNeu;
     xK = round( map(xNeuF,xU,xO,0,w));                 
     yK = round (map(yNeuF,yU,yO,h,0));          
     stroke(farben[j]); 
    // strokeWeight(2);
     point(xK,yK);   
     xAlt = xNeu;
     yAlt = yNeu;
     i++;
   }
   i=0;  
}
